DP 34. Wildcard Matching | Recursive to 1D Array Optimisation 🔥

แชร์
ฝัง
  • เผยแพร่เมื่อ 28 ส.ค. 2024

ความคิดเห็น • 478

  • @mohitagarwal3639
    @mohitagarwal3639 2 ปีที่แล้ว +164

    Hey Striver you have helped me a lot in logic building .
    I paused the video right at 4:42 after understanding what question is all about and was able to code the solution all by myself.
    It feels really great when I solves a question (all by myself) which was next to impossible for me a month back.
    I always thank you the moment green signal of "Correct Answer" pops up and you deserve it.
    Understood🙂🙂

  • @sayandey2492
    @sayandey2492 11 หลายเดือนก่อน +18

    I remember about 2 months back, I had seen this problem and closed it after reading the problem statement for 2 minutes, understanding it can't be solved by me in any way. Today I am able to solve it within 30 minutes without seeing the video at all 🤯. Thanks Striver. You have love of all aspiring coders 🙌 🙌

  • @toshangupta7306
    @toshangupta7306 2 หลายเดือนก่อน +3

    More optimized version
    for computing 0th index of curr --> It is checking if the string p contains only *
    If previously we found 0th index to be false that means it contains char other than * --> Assign false
    Otherwise if previously it was true --> If curr index of string is * --> true else ->> false
    bool isMatch(string s, string p) {
    int m=s.length();
    int n=p.length();
    vectorprev(m+1,false),curr(m+1);
    prev[0]=true;
    for(int i=1;i

  • @yashshetty7326
    @yashshetty7326 ปีที่แล้ว +17

    I could have never thought that I could solve a Leetcode hard question by myself. This dp playlist is the best playlist in TH-cam and I thank you Striver for such an amazing playlist.

    • @deviprasad_bal
      @deviprasad_bal ปีที่แล้ว +1

      same dude, i just can't believe how easy striver made string matching dp for me, I did this myself and I can't believe it.

    • @romanshrestha7510
      @romanshrestha7510 10 วันที่ผ่านมา

      same dude i can't believe this

  • @melvinfrancis7525
    @melvinfrancis7525 2 ปีที่แล้ว +62

    In tabulation to check the base case instead of iterating from the beginning every time you can simply check if the previous state is true and the current value = '*".
    for(int i = 1 ; i

    • @parthsalat
      @parthsalat 2 ปีที่แล้ว +3

      Dev Manus

    • @cheriviralakarthik
      @cheriviralakarthik 2 ปีที่แล้ว

    • @ankitmeena5637
      @ankitmeena5637 ปีที่แล้ว

      can you explain it more clearly ?? please

    • @kaushik.aryan04
      @kaushik.aryan04 ปีที่แล้ว

      you are a real one

    • @anonymous10906
      @anonymous10906 9 หลายเดือนก่อน

      Previous state 1 signifies that upto that index all characters are '*' and if the current index in wild string is also '*' then the wild string upto the current index has all its characters as '*'@@ankitmeena5637

  • @stolenkid2121
    @stolenkid2121 2 ปีที่แล้ว +30

    I messed up this question with regular expression matching, I think regex matching is a bit tougher than this, thank you for this explanation, I hope the next lecture will be regex matching one . I solved that regular expression matching but would like to hear again from you😊

    • @takeUforward
      @takeUforward  2 ปีที่แล้ว +8

      Its the same question !

    • @amitkoushik5504
      @amitkoushik5504 ปีที่แล้ว +4

      @@takeUforward it's similar not same

    • @saibingi6980
      @saibingi6980 ปีที่แล้ว +2

      @@amitkoushik5504 yes

    • @arunm619
      @arunm619 2 หลายเดือนก่อน

      @stolenkid2121 how is it different from Wildcard matching

    • @brokegod5871
      @brokegod5871 หลายเดือนก่อน

      How did you solve it?

  • @gaurishaaaa
    @gaurishaaaa 2 หลายเดือนก่อน +1

    DP on strings understood ✅
    From hating and fearing DP to love doing it.. all the way grateful to you.

  • @ahanavishwakarma3956
    @ahanavishwakarma3956 2 ปีที่แล้ว +7

    I was able to think of almost the whole approach without watching your explanation. Couldn't be more grateful!

  • @adebisisheriff159
    @adebisisheriff159 7 หลายเดือนก่อน +3

    I do not know how to thank you Striver..... Thank you for being an amazing person and coder.
    Thank you for being a shoulder to lean on..... 🥰🥰🥰🥰🥰🥰🥰

  • @prerna_mishra
    @prerna_mishra 2 ปีที่แล้ว +22

    This series has brought me to the point where I can build intuition and code by myself within minutes ( which was unimaginable approx 15 days back). All thanks to you nd your constant efforts!! Extremely Grateful _/\_

    • @user-tp2ds2ju4l
      @user-tp2ds2ju4l 11 หลายเดือนก่อน

      How much time did you take to complete this playlist?

    • @prerna_mishra
      @prerna_mishra 11 หลายเดือนก่อน

      15 days@@user-tp2ds2ju4l

    • @Rahul_Mongia
      @Rahul_Mongia 11 วันที่ผ่านมา

      @@user-tp2ds2ju4l 8 months

  • @gauravbhardwaj6656
    @gauravbhardwaj6656 2 ปีที่แล้ว +30

    for more optimization we can merge multiple continuous '*' with single '*' before applying DP and we can reduce those last 1d array to single integer value.

  • @ankitpandey7262
    @ankitpandey7262 2 ปีที่แล้ว +4

    Anyone following the playlist from the start can able to do these Leetcode Hard Ques easily without watching the video.
    Thanks for this amazing content.

  • @mantrarajgotecha3055
    @mantrarajgotecha3055 2 ปีที่แล้ว +10

    You just not make us understood dp on strings but you make us feel how to think and feel about dp on strings.
    Hats off you !!

  • @raghuvamsi4879
    @raghuvamsi4879 11 หลายเดือนก่อน +2

    Tysm striver, the way you explained these dp problems so far is really really awesome, In fact I was able to come up the last 3 problems in "DP on Strings" set by myself! This is all because, your explanation for previous questions is damn good which made me understand the true essence of dp! Keep the 🔥going and all the very best striver ❤!

  • @vishious14
    @vishious14 7 หลายเดือนก่อน +2

    Striver, you’re the greatest teacher I’ve ever had. I was able to build the logic for this question and the previous question all by myself and solved in all three approaches. Thanks a lot man. This is GOLD !!!!

  • @parthsalat
    @parthsalat 2 ปีที่แล้ว +10

    *Notes*
    1. Those who already know the question can start the video from 4:40
    2. Using .at() operator for string and vectors does automatic bound checking. It's much safer than using [ ]
    😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏
    *Important timestamps*
    Recursion
    - code: 29:47
    - complexity: 26:00
    Memoization
    - code: 31:00
    - complexity: 26:55
    Tabulation code: 38:21
    Space optimisation code: 42:26
    😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏😏
    *Striver's this code snippet (**38:07**) runs in O(N^2) time. I've optimised it to run in O(N) time*
    // ---------------------------------- Code snippet begins ----------------------------------------
    //if there is no text, the pattern must be all * for answer to be true
    for(int patternIndex=1; patternIndex

  • @anhadwadhwa2844
    @anhadwadhwa2844 2 ปีที่แล้ว +1

    We can optimise this further using a single 1-d array as well, by taking a variable storing prev value at j-1 index. Moreover, the third base case can be optimised to curr[0]=prev[0]&&(p[i-1]=='*');
    and the code for 1-1d array is:
    vector prev(m+1, 0);
    prev[0]=1;
    for(int i=1; i

    • @goooo9561
      @goooo9561 ปีที่แล้ว

      nice approach

  • @abhishekNITT
    @abhishekNITT ปีที่แล้ว +1

    Base Case for Tabulation
    dp[0][0]=true;
    if(pattern[0]=='*')
    {
    int i=1;
    while(i

  • @devanshkumar3816
    @devanshkumar3816 2 ปีที่แล้ว +3

    The way you taught the space optimization in previous videos it got onto my tip and was able to space optimize the code on my own...
    Much respect !!! orz
    I did space optimisation this way:
    int n = s.length(), m = t.length();
    vector dp(m + 1, false);
    dp[0] = true;
    for(int j = 1; j

  • @koushalsharma7041
    @koushalsharma7041 2 ปีที่แล้ว +3

    Understood the entire DP on Strings. Thankyou so much for the quality videos !!!!!!!!!!!!

    • @ani68
      @ani68 2 ปีที่แล้ว

      +1

    • @ArnabJhaYT
      @ArnabJhaYT 2 ปีที่แล้ว

      @@ani68 found the legend aniruddha :)

  • @amanbhadani8840
    @amanbhadani8840 2 ปีที่แล้ว +9

    I loved the way you handled all the valid number of charcters possible starting from zero for astrik.I thought of looping it but your explanation was so much simple and easy to understand.

  • @kazuma0803
    @kazuma0803 2 ปีที่แล้ว +23

    First hard question done on my own. Thank you Striver

    • @amitkoushik5504
      @amitkoushik5504 ปีที่แล้ว +2

      I also solved it till space optimization on my own ....and started dancing😂❤❤🎉all credits to striver🎉❤

    • @GodOfFaith
      @GodOfFaith ปีที่แล้ว +4

      you worte the code on your own , doing question on your own means , you found the logic on your own , which you didn't but still its good that you solved the problem

  • @naman_goyal
    @naman_goyal 2 ปีที่แล้ว +6

    Amazing content. Now I start solving before watching video and then watch it completely to learn how to explain better and writing clear code. Thankyou ❤️

  • @googleit2490
    @googleit2490 9 หลายเดือนก่อน +1

    Done and dusted in the DP revision :)
    (31 mins)
    Nov'17, 2023 10:11 pm

  • @ameypate9610
    @ameypate9610 หลายเดือนก่อน

    Approach to this problem is explained well, and optimizations are interesting to perform.

  • @mdmudassiralam5490
    @mdmudassiralam5490 2 ปีที่แล้ว +4

    We can make the base case simpler
    if(ind1

  • @codermal
    @codermal 2 ปีที่แล้ว +1

    We can further optimize by keeping a flag and checking for current characters only in base case
    (Ex: pattern = ****ab, text=ab)
    i.e:
    int m=pattern.size(),n=text.size();
    vector prev(n+1,false),temp(n+1,false);
    prev[0]=true;
    bool flag=true;
    for(int i=1;i

  • @johar3737
    @johar3737 ปีที่แล้ว +2

    Understood. Now I am able to make logic and intuition behind the question. Thanks Striver

  • @sauravchandra10
    @sauravchandra10 ปีที่แล้ว +3

    Understood the entire DP on strings, thanks a lot!

  • @stith_pragya
    @stith_pragya 7 หลายเดือนก่อน +1

    UNDERSTOOD.....Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @user-is6ky7pp2n
    @user-is6ky7pp2n 17 วันที่ผ่านมา

    Sir Hatts Off to you, Keep Going...

  • @Parthj426
    @Parthj426 หลายเดือนก่อน

    #Understood | Wonderful series of DP on strings | Definitely feeling confident !

  • @ibtesamansari
    @ibtesamansari 6 หลายเดือนก่อน

    Bro , I literally enjoyed this lecture, I am filled with joy , Awesome explanation

  • @hashcodez757
    @hashcodez757 22 วันที่ผ่านมา

    "UNDERSTOOD BHAIYA!!"

  • @shubhamsalunkhe137
    @shubhamsalunkhe137 2 ปีที่แล้ว +2

    Understood
    It was great learning DP on strings from your striver🙌🙌
    Thank you for everything you have done🙌

  • @ChandraSekhar-mz8xy
    @ChandraSekhar-mz8xy 2 ปีที่แล้ว +6

    I would also like to add :
    > curr[0] depend on prev[0] and if the current char is '*' o r not.
    > instead of 'isAllStars' method (given in article) you can use this single line :
    curr[0] = p.charAt(i-1) == '*' && prev[0];

  • @deependrasinghshekhawat8107
    @deependrasinghshekhawat8107 ปีที่แล้ว

    Solved this questions along with Regular Exapression matching, all on my own, All thanks to you Striver!!!

  • @vaibhavagarwal1479
    @vaibhavagarwal1479 7 หลายเดือนก่อน

    we can also use this two line code for setting curr[0] and it saves some time as well just we also have to initialize flag as true outside the first for (i) loop and this will be placed in inside first for loop just like striver's.. Thankyou striver for all the efforts
    if(flag == true && pattern[i-1] != '*')flag = false;
    curr[0]=flag;

  • @mohaimenchowdhury
    @mohaimenchowdhury 6 หลายเดือนก่อน

    Hey Striver!! I am a great fan of your videos. Can you make series for the other string matching algorithms like KMP/Rabin Karp also? I know you are the best person right now to teach those at very intuitive level.

  • @prabhakaran5542
    @prabhakaran5542 4 หลายเดือนก่อน +1

    Understood ❤

  • @ajitpalsingh606
    @ajitpalsingh606 25 วันที่ผ่านมา +1

    Done Recursion on my own

  • @sarveshsugandhbarnwal9809
    @sarveshsugandhbarnwal9809 2 ปีที่แล้ว +4

    So blessed to have teacher like You, Very clean explanation. Thank You Striver

  • @hitengarg3167
    @hitengarg3167 2 ปีที่แล้ว +1

    Keep up the good work Bro!!🔥🔥🔥. Always scared of this question, whenever I see it, I immediately skip it...But you made it so so so simple to understand, that without even looking at the solution I was able to come up with code. The entire DP series is AWESOME🔥🔥🔥

  • @tn4122
    @tn4122 2 ปีที่แล้ว +4

    Is the code working for everyone in leetcode? If yes please share the code. I'm not getting all the test cases passed.

    • @maxtennyson01
      @maxtennyson01 ปีที่แล้ว +1

      just sawp the strings at the beginning and try again

  • @ajitpalsingh606
    @ajitpalsingh606 25 วันที่ผ่านมา

    Here Striver is assuming S1 to b ehaving character * and ? and S2 string that is to be matched.
    But In Leetcode ,there is opposite S1 string is to be matched and S2 string contains * and ?
    therefore ,Base condition will change
    if(i

  • @kunalgupta343
    @kunalgupta343 19 วันที่ผ่านมา

    I think we don't need nested loop for *,
    for(let j=1; j

  • @suyashjain3223
    @suyashjain3223 9 หลายเดือนก่อน

    Completed DP on strings successfully!!

  • @ritikshandilya7075
    @ritikshandilya7075 2 หลายเดือนก่อน

    Thankyou so much for great explanation Striver

  • @suhaanbhandary4009
    @suhaanbhandary4009 ปีที่แล้ว +1

    Understood!!, and solved this question before explanation, Thanks for such series !!

  • @fanofabdevillersandmathslo5960
    @fanofabdevillersandmathslo5960 13 ชั่วโมงที่ผ่านมา +1

    Understood

  • @AyushGupta-re5yp
    @AyushGupta-re5yp ปีที่แล้ว +1

    This is legit insane! Gold Content.
    1st Hard Problem on my own. All credits to you!

  • @keshavprasad1017
    @keshavprasad1017 9 หลายเดือนก่อน

    You made DP feel like a cup of coffee ☕️ ...

  • @preetisahani5054
    @preetisahani5054 10 หลายเดือนก่อน

    Awesome explanation, I missed the all stars base case while solving on my own,

  • @champion5946
    @champion5946 ปีที่แล้ว

    US
    for base case In C++ we can also do
    for(int i = 1; i

  • @ganeshkamath89
    @ganeshkamath89 2 ปีที่แล้ว +3

    Thanks Striver. Understood.
    Why have you done bitwise or (|) instead of logical or (||) for asterisk case?

    • @anuragpandey8165
      @anuragpandey8165 2 ปีที่แล้ว +1

      It is because the only possible return values of function are 0 and 1. Hence the bitwise OR can return the correct answer as 0 | 0 = 0, 0 | 1 = 1, 1 | 0 = 1, 1 | 1 = 1. Also the bitwise operations are faster and striver is a CP guy.

    • @ganeshkamath89
      @ganeshkamath89 2 ปีที่แล้ว

      @@anuragpandey8165 , why have you written 0 | 0 = 1?
      Also are you sure that bitwise or is faster? because even logical or does the same
      0||0 = 0
      0||1 = 1
      1||0 = 1
      1||1 = 1
      Where as bitwise or does the operation bitwise (agreed that we are dealing with 1 bit here, but still I am not convinced).

  • @OMPRAKASH-is7fj
    @OMPRAKASH-is7fj 9 หลายเดือนก่อน +1

    greatful to u

  • @dsp-io9cj
    @dsp-io9cj 10 หลายเดือนก่อน

    dp[0][0]=1;
    for(int i=1;i

  • @jasmeenkaur6001
    @jasmeenkaur6001 2 ปีที่แล้ว +1

    thank you so much striver...................... First time in my life i understood tabulation and able to write code by myself. thankyou so soooooooooooo muchhhhhhhhhhhhhhhhhhhhhh.

  • @UECAshutoshKumar
    @UECAshutoshKumar 2 หลายเดือนก่อน +1

    Understood !

  • @sauravlogsvio1891
    @sauravlogsvio1891 2 ปีที่แล้ว

    This is awesome.
    But the base case -> where pat[i] remains.. while string is exhausted, probably needs some more treatment.
    For example - "c*a*b" matches with "aab" because - c* means 0 c's or any number of characters. For instance, ab*c matches "ac", "abc", "abbc", "abbbc", and so on..
    Need to check if all the chars are '*' or its (char) followed by '*' like [w*x*y*....] kind of pattern which means there can be no characters at all.

    • @chetanraghavv
      @chetanraghavv 2 ปีที่แล้ว

      I think you are confusing this question with Regular Expression Matching
      Here, "c*a*b" does not match "aab"
      because, if first * is a and second is NULL then string becomes "caab" which does not match "aab"

  • @sahilgagan2242
    @sahilgagan2242 2 ปีที่แล้ว +3

    61% done bro thankyou so much ....

  • @electricindro2236
    @electricindro2236 7 หลายเดือนก่อน

    Amazing explanation! Understood!

  • @Your_Boy_Suraj
    @Your_Boy_Suraj ปีที่แล้ว +2

    Wrong Answer
    276 / 354 testcases passed
    Input
    s =
    "aab"
    p =
    "c*a*b"
    Use Testcase
    Output
    false
    Expected
    true

    • @KaifKhan-sb2yr
      @KaifKhan-sb2yr 8 หลายเดือนก่อน

      same with me did you got the solution ?

  • @rahultiwari7714
    @rahultiwari7714 2 ปีที่แล้ว +11

    hats down sir!!!
    this is happen when god himself came on earth to teaches us this beautiful concept...
    and thank u soo much for whatever u r doing for us...
    and mark my word agar coding and logic building me revolution aayi toh voh appke vajah se hi aayegi... thank u soooo os ssoooo much

  • @RohitKumar-dy2gc
    @RohitKumar-dy2gc 9 หลายเดือนก่อน

    just saw the recursion and rest is super super simple

  • @LowkeyCoder
    @LowkeyCoder 9 หลายเดือนก่อน

    "Understood"thank you!

  • @arijitdas4560
    @arijitdas4560 2 ปีที่แล้ว +1

    in 24:34 there is nother case that if in s1[ind]=='?' then also I can return true....but here the else case is hadling that part...done wisely

  • @arpankoley4256
    @arpankoley4256 7 หลายเดือนก่อน

    For the leetcode version pattern p is declared second , so in 1D array optimization i have taken prev array as dp[m+1] = {false};
    Here is a simplified base case for this-->
    dp[0] = true;
    for(int j=1;j

  • @lohesh9822
    @lohesh9822 2 หลายเดือนก่อน +1

    For the base case, couldnt you just write ,
    for(int i=1;i

  • @felixkimbu8484
    @felixkimbu8484 ปีที่แล้ว

    Was very helpful. My problem did not require '?' so I just removed it from the condition. Also, loops where not allowed so I created another recursive function to use it in place of the for loop.

  • @abhinavgupta4778
    @abhinavgupta4778 ปีที่แล้ว

    Just an observation: Space optimization into two array will be very easy if you make the dp matrix as dp[text.size][pattern.size] rather than dp[pattern][text].

  • @mayankbhugra6193
    @mayankbhugra6193 2 ปีที่แล้ว +2

    Amazing !!! explanation and energy. Thanks for the content ❤

  • @arpnasjs9825
    @arpnasjs9825 ปีที่แล้ว

    Did space optimization on my own in a different way...Thank u for this series.

  • @ztrixx3280
    @ztrixx3280 2 ปีที่แล้ว +1

    when i was trying to solve this question, i thought of looping through until i find next character to star(*), recursion doesn't even came across my mind at 5:51 (video timestamp)
    after getting WAs i realised that it was meant to be solve the way Raj explained.

  • @Hrushi_2000
    @Hrushi_2000 11 หลายเดือนก่อน

    Understood. Thankyou Sir.

  • @pratyakshsinha6292
    @pratyakshsinha6292 ปีที่แล้ว +2

    fails for test case
    pattern = "*"
    text = "aa"

  • @wisdomkhan
    @wisdomkhan ปีที่แล้ว +1

    You are one of the most successful and disciplined persons I have known in my life.

  • @chanchalroy3417
    @chanchalroy3417 7 หลายเดือนก่อน

    Just wow 😮 understood 👏❤️

  • @DevashishJose
    @DevashishJose 7 หลายเดือนก่อน

    Understood thank you so so much.

  • @cod-phy1646
    @cod-phy1646 ปีที่แล้ว

    Thank You Striver you made the DP journey so Easy...God bless you

  • @shubhgaming3348
    @shubhgaming3348 2 หลายเดือนก่อน

    understood bhaiya

  • @subhro9769
    @subhro9769 2 ปีที่แล้ว +5

    Thank you Striver Sir, because of all the previous videos and how good you taught us DP, I myself tried the question myself, before seeing your video and my solution worked in first go.
    This is a great achievement for me to solve a problem that is of Hard level in Leetcode.
    Thank you sir

  • @tasneemayham974
    @tasneemayham974 10 หลายเดือนก่อน

    BESTT TEACHERR EVERR!!!

  • @Sara-ed3jq
    @Sara-ed3jq ปีที่แล้ว

    I was able to solve the question and pass 80% of test cases by myself, which was possible only because of you. Understood

  • @itslol6504
    @itslol6504 ปีที่แล้ว

    Understood ! This Guy is making videos at 4 am !! Crazy

  • @akshayjain8810
    @akshayjain8810 2 ปีที่แล้ว +2

    can we run a loop when pattern[ i ] == ' * ' and return accordingly

  • @sarthakyadav9950
    @sarthakyadav9950 ปีที่แล้ว

    Instead of using two 1-D Arrays we can further space optimize it using a single array. For every index we require value of it's prev row and prev col if char matches and if it does not match we require prev row same col and same row prev col. We just have to maintain a variable that can store prev row prev col value and have to update it accordingly.

    • @karankaira
      @karankaira 7 หลายเดือนก่อน

      @sarthakyadav9950 can u pls paste the code here , i tried but it is failing for "a" and ""

  • @pranavsharma7479
    @pranavsharma7479 2 ปีที่แล้ว +2

    this ques and regex ques are completely different, dont confuse b/w them

  • @abhirupray2494
    @abhirupray2494 8 หลายเดือนก่อน

    Understood completely

  • @mriduljain6809
    @mriduljain6809 ปีที่แล้ว

    "Understood"
    Probably the best playlist on Dp.. Keep going Bhaiya::))

  • @AsifHussain-gl4ci
    @AsifHussain-gl4ci 3 หลายเดือนก่อน +1

    what will happen if * or ? are in s2 i am not understanding how that case is considered

  • @adarshmishra7113
    @adarshmishra7113 ปีที่แล้ว

    bhaiya loved your explanation i studied almost the whole DS and ALGO by your channel only , thankyou so much for all the content you had put and presently you are putting

  • @srikrishnabejawada3126
    @srikrishnabejawada3126 2 หลายเดือนก่อน

    amazing ❤

  • @dheerajsharma5492
    @dheerajsharma5492 2 ปีที่แล้ว +1

    I got it. hats off for space optimization. 👌

  • @gunduboinadileep9523
    @gunduboinadileep9523 8 หลายเดือนก่อน

    understood!!. thank you

  • @joshrak3412
    @joshrak3412 ปีที่แล้ว

    base case in tabulation for this condition (i>=0 && j

  • @raghavmanish24
    @raghavmanish24 9 วันที่ผ่านมา

    understood ....this time i skip the optimisation of tabulation method

  • @pragyanandsingh6673
    @pragyanandsingh6673 6 หลายเดือนก่อน

    Understood !!

  • @nikhilkotiya8062
    @nikhilkotiya8062 2 ปีที่แล้ว +3

    I can code solution without see your solutions, thank you a lot bhaiya for making such kind of video ❤️❤️❤️❤️. Its help me a lot for improving my skill and you know what my favorite topic dp and if some one ask me why then I reply them by saying because I learn from striver bhaiya🤩.

  • @shisui3645
    @shisui3645 ปีที่แล้ว +1

    Gives an error for pattern="*" and text="aa"